<?php
/**
 * @version 1.0 2012-06-27
 * @package Joomla
 * @subpackage OS Property
 * @copyright (C)  2012 Ossolution
 * @license see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access.' );

class xmap_com_osproperty{

	function getTree( &$xmap, &$parent, &$params) {
        $link_query = parse_url($parent->link);
        if (!isset($link_query['query'])) {
            return;
        }
        parse_str( html_entity_decode($link_query['query']), $link_vars );
        //$catid = JArrayHelper::getValue($link_vars,'id',0);
        $task = JArrayHelper::getValue($link_vars,'task',0);
        $type_id = JArrayHelper::getValue($link_vars,'type_id',0);
        $id = JArrayHelper::getValue($link_vars,'id',0);
        $category_id = JArrayHelper::getValue($link_vars,'category_id',0);
        $country_id = JArrayHelper::getValue($link_vars,'country_id',0);

        $include_props = JArrayHelper::getValue( $params, 'include_props',1,'' );
        $include_props = ( $include_props == 1 || ( $include_props == 2 && $xmap->view == 'xml') || ( $include_props == 3 && $xmap->view == 'html'));
        $params['include_props'] = $include_props;

        $priority = JArrayHelper::getValue($params,'cat_priority',$parent->priority,'');
        $changefreq = JArrayHelper::getValue($params,'cat_changefreq',$parent->changefreq,'');
        if ($priority  == '-1')
            $priority = $parent->priority;
        if ($changefreq  == '-1')
            $changefreq = $parent->changefreq;

        $params['cat_priority'] = $priority;
        $params['cat_changefreq'] = $changefreq;

        $priority = JArrayHelper::getValue($params,'prop_priority',$parent->priority,'');
        $changefreq = JArrayHelper::getValue($params,'prop_changefreq',$parent->changefreq,'');
        if ($priority  == '-1')
            $priority = $parent->priority;
        if ($changefreq  == '-1')
            $changefreq = $parent->changefreq;

        $params['prop_priority'] = $priority;
        $params['prop_changefreq'] = $changefreq;
        $params['limit'] = '';
        $params['days'] = '';

        if ( $include_props ) {                
            $limit = JArrayHelper::getValue($params,'max_props','','');

            if ( intval($limit) )
                $params['limit'] = ' LIMIT '.$limit;

            $days = JArrayHelper::getValue($params,'max_age','','');
            if ( intval($days) )
                $params['days'] = ' AND p.created >= \''.date('Y-m-d H:m:s', ($xmap->now - ($days*86400)) ) ."' ";
        }

        //xmap_com_osproperty::getOspropertyTree( $xmap, $parent, $params, $catid );
        
        switch ($task){
        	case "property_listing":
        		xmap_com_osproperty::getOspropertyTree($xmap, $parent, $params, $type_id, $category_id,$country_id);
        	break;
        }
	}
	

	function getOspropertyTree ( &$xmap, &$parent, &$params, &$type_id, &$category_id, &$country_id ) {
		$db = JFactory::getDBO();

        $query = 'SELECT id,pro_name '
                .' FROM #__osrs_properties '
                .' WHERE approved = 1 AND published = 1';
		if($type_id > 0){
			$query .= " and type_id = '$type_id' " ;
		}
		if($category_id > 0){
			$query .= " and category_id = '$category_id' " ;
		}
		if($country_id > 0){
			$query .= " and country = '$country_id'";
		}

		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$xmap->changeLevel(1);
		for($i=0;$i<count($rows);$i++) {
			$prop = $rows[$i];
            $node = new stdclass;
			$node->id           = $parent->id;  // Itemid
			$node->uid          = $parent->uid .'d'.$prop->id; // Unique ID for the property
            $name 				= $prop->pro_name;
            $node->name			= $name;
            $node->newsItem 	= 0;
            $node->link         = 'index.php?option=com_osproperty&task=property_details&id='.$prop->id;
			$node->priority     = $params['prop_priority'];
			$node->changefreq   = $params['prop_changefreq'];
			$node->tree         = array();
			$xmap->printNode($node);                
		}
		$xmap->changeLevel(-1);
	}
}